#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <string.h>
#include "CAboutDlg.h"
#include "..\resource.h"

#define VERSION_TEXT_FILENAME "ver.txt"

CAboutDlg::CAboutDlg(){
	m_hWnd = NULL;
	m_hInst = NULL;
}

CAboutDlg::~CAboutDlg(){
}
    
//R}hnh
void CAboutDlg::OnOK(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	EndDialog(hDlg,IDOK);
}

//bZ[Wnh
int CAboutDlg::OnWmInitDlg(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	m_hWnd = hDlg;
	m_hInst = (HINSTANCE)GetWindowLong(hDlg,GWL_HINSTANCE);
	char szStr[1024];

	char szPath[MAX_PATH];
	FILE *fp;

	//obt@NA
	ZeroMemory(&szStr[0],sizeof(szStr));

	//앨̕\LsȂ
	LoadString(m_hInst,IDS_STR_ABOUT_CP,&szStr[0],sizeof(szStr));

	//GfBbg{bNɔf
	SetDlgItemText(hDlg,IDC_EDIT_COPYRIGHT,szStr);

	//o[Wݒ肷
	strcpy(szPath,VERSION_TEXT_FILENAME);
	sprintf(szStr,"Ver.0.01");

	fp = fopen(szPath,"rt");
	if(fp != NULL){
		fgets(szStr,sizeof(szStr),fp);
		fclose(fp);
	}

	SetDlgItemText(hDlg,IDC_STATIC_VERSION,szStr);

	return 0;
}

int CAboutDlg::OnWmCommand(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	switch(GET_WM_COMMAND_ID(wP,lP)){
	case IDOK:
		OnOK(hDlg,msg,wP,lP);
		break;
	}

	return 0;
}

//bZ[Wv-W[
LRESULT CAboutDlg::DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	switch (uMsg){
	case WM_COMMAND:
		return OnWmCommand(hWnd,uMsg,wParam,lParam);

	case WM_INITDIALOG:
		return OnWmInitDlg(hWnd,uMsg,wParam,lParam);

	case WM_DESTROY:
		RemoveProp(hWnd, PTDIGI_DLG_PROP);
		break;
	}

	return 0;
}
