//////////////////////////////////////////////////////////////////////////
//BMPJPGɕϊ
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern "C"{
#include "jpeglib.h"
}

typedef struct tagBITMAPINFOHEADER{
        unsigned int      biSize;
        int       biWidth;
        int       biHeight;
        unsigned short       biPlanes;
        unsigned short       biBitCount;
        unsigned int      biCompression;
        unsigned int      biSizeImage;
        int       biXPelsPerMeter;
        int       biYPelsPerMeter;
        unsigned int      biClrUsed;
        unsigned int      biClrImportant;
} BITMAPINFOHEADER;

int BmpToJpegSaveFile( FILE *fp, BITMAPINFOHEADER *pbmih, int quality, int progression ) {
    int   i, j;
   	int   bmp_row_bytes;
    unsigned char *bmp_image;
    unsigned char *src, *dest;

    struct jpeg_compress_struct cinfo;
    struct jpeg_error_mgr jerr;

    JSAMPLE * image_buffer;
    JSAMPROW row_pointer[1];      // pointer to JSAMPLE row[s] 
    int row_stride;               // physical row width in image buffer 
    int image_height;
    int image_width;

	if(pbmih == NULL)return 0;
	if(pbmih->biBitCount != 24)return 0;
	
    //C[WTCYݒ肷
    image_width = pbmih->biWidth;
    image_height = pbmih->biHeight;

    // JPEGkIuWFNg蓖ĂāA
    cinfo.err = jpeg_std_error(&jerr);
    jpeg_create_compress(&cinfo);

    jpeg_stdio_dest(&cinfo, fp);

    // kp̃p[^ݒ
    cinfo.image_width  = image_width;     // C[W̃sNZƍ
    cinfo.image_height = image_height;
    cinfo.input_components = 3;           // sNZ̐F
    cinfo.in_color_space = JCS_RGB;       // J[Xy[X

    // ftHgkp[^ݒ肷
    jpeg_set_defaults(&cinfo);

    // ftHgp[^̐ݒ
    jpeg_set_quality(&cinfo, quality, TRUE );

    //* Progression IvVǉ  
    if( progression )  jpeg_simple_progression (&cinfo);

    // kJn
    jpeg_start_compress(&cinfo, TRUE);

    row_stride = image_width * 3; // JSAMPLEs per row in image_buffer
    image_buffer = new unsigned char[row_stride];
    bmp_row_bytes = (image_width * 3 + 3) / 4 * 4;  // DWORD E
    bmp_image = (unsigned char *)pbmih + sizeof(BITMAPINFOHEADER);

    i = image_height - 1;
    while (cinfo.next_scanline < cinfo.image_height) {
        // BMP ͊i[`㉺tB
        dest = image_buffer;
        src = &bmp_image[ i * bmp_row_bytes ];
        for( j = 0; j < image_width; j++ ) {
            *dest++ = src[ 2 ];
            *dest++ = src[ 1 ];
            *dest++ = src[ 0 ];
            src += 3;
        }
        i--;

        row_pointer[0] = image_buffer;
        jpeg_write_scanlines(&cinfo, row_pointer, 1);
    }

    // kI
    jpeg_finish_compress(&cinfo);

    // JPEG kIuWFNg̊J
    jpeg_destroy_compress(&cinfo);

    delete [] image_buffer;
    image_buffer = 0;

    return( TRUE );
}


