#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>
#include "CPropCfgDlg.h"
#include "..\resource.h"
#include "..\ComCtrl\CTreeView.h"

#include "..\Util\StrUtil.h"

//^uRg[pID

//\L
#define IDS_TREE_APP_CFG		"AvP[V̐ݒ"
#define IDS_TREE_REC			"^"
#define IDS_TREE_SNAP			"Î~"
#define IDS_TREE_SKIN			"XL"
#define IDS_TREE_REMOCON		"R"
#define IDS_TREE_DRIVER			"hCo"
#define IDS_TREE_PREVIEW		"\ݒ"

#define HELPER_RELEASE_DIALOG(x){if( x != NULL){                                        \
	                                  if(x->m_hWnd != NULL)DestroyWindow(x->m_hWnd);    \
									  delete x;                                         \
                                      x = NULL;}}

CPropCfgDlg::CPropCfgDlg(){
	m_hWnd = NULL;
	m_hInst = NULL;
	
	//_CAÕCX^X̍쐬
	m_pDlgRec		= new CVidRecDlg;
	m_pDlgSnap		= new CVidSnapShotDlg;
	m_pDlgSkin		= new CVidSkinDlg;
	m_pDlgRemocon	= new CRmtDlg;
	m_pDlgDriver	= new CDriverDlg;
	m_pdlgPreview	= new CVidPreviewDlg;

	//l̐ݒ
	m_iSelDialog = PROP_PAGE_REC;
}

CPropCfgDlg::~CPropCfgDlg(){
	HELPER_RELEASE_DIALOG(m_pDlgRec);
	HELPER_RELEASE_DIALOG(m_pDlgSnap);
	HELPER_RELEASE_DIALOG(m_pDlgSkin);
	HELPER_RELEASE_DIALOG(m_pDlgRemocon);
	HELPER_RELEASE_DIALOG(m_pDlgDriver);
	HELPER_RELEASE_DIALOG(m_pdlgPreview);
}

//////////////////////////////////////////////////////////////////////////////
//o֐
//////////////////////////////////////////////////////////////////////////////
//IĂ^uԍ擾
//:Ȃ
//߂l:IĂACe̔ԍ
int CPropCfgDlg::GetSelectTab(void){
	CTreeView *pTree;
	TVITEM tvitem;
	
	//c[r[̐ݒsȂ
	pTree = new CTreeView;
	if(pTree == NULL)return PROP_PAGE_REC;

	pTree->hWnd = GetDlgItem(m_hWnd,IDC_TREE_CFG);

	ZeroMemory(&tvitem,sizeof(TVITEM));
	tvitem.mask = TVIF_PARAM;
	tvitem.hItem = pTree->GetSelection();
	pTree->GetItem(&tvitem);

	delete pTree;

	if((HWND)tvitem.lParam == m_pDlgRec->m_hWnd)return PROP_PAGE_REC;
	if((HWND)tvitem.lParam == m_pDlgSnap->m_hWnd)return PROP_PAGE_SNAP;
	if((HWND)tvitem.lParam == m_pDlgSkin->m_hWnd)return PROP_PAGE_SKIN;
	if((HWND)tvitem.lParam == m_pDlgRemocon->m_hWnd)return PROP_PAGE_REMOCON;
	if((HWND)tvitem.lParam == m_pDlgDriver->m_hWnd)return PROP_PAGE_DRIVER;
	if((HWND)tvitem.lParam == m_pdlgPreview->m_hWnd)return PROP_PAGE_PREVIEW;

	return PROP_PAGE_REC;
}

//////////////////////////////////////////////////////////////////////////////
//NotifybZ[Wnh
LONG CPropCfgDlg::OnTvnSelChange(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	LPNMTREEVIEW pnmtv;

	pnmtv = (LPNMTREEVIEW)lP;

	if(pnmtv->itemNew.lParam != NULL){
		
		//_CAO\ɂ
		if(m_pDlgRec->m_hWnd != NULL)		ShowWindow(m_pDlgRec->m_hWnd,SW_HIDE);
		if(m_pDlgSnap->m_hWnd != NULL)		ShowWindow(m_pDlgSnap->m_hWnd,SW_HIDE);
		if(m_pDlgSkin->m_hWnd != NULL)		ShowWindow(m_pDlgSkin->m_hWnd,SW_HIDE);
		if(m_pDlgRemocon->m_hWnd != NULL)	ShowWindow(m_pDlgRemocon->m_hWnd,SW_HIDE);
		if(m_pDlgDriver->m_hWnd != NULL)	ShowWindow(m_pDlgDriver->m_hWnd,SW_HIDE);
		if(m_pdlgPreview->m_hWnd != NULL)	ShowWindow(m_pdlgPreview->m_hWnd,SW_HIDE);

		//_CAO\		
		ShowWindow((HWND)pnmtv->itemNew.lParam,SW_SHOW);
		
		//Iꂽڂێ
		if(m_pDlgRec->m_hWnd == (HWND)pnmtv->itemNew.lParam)		m_iSelDialog = PROP_PAGE_REC;
		if(m_pDlgSnap->m_hWnd == (HWND)pnmtv->itemNew.lParam)		m_iSelDialog = PROP_PAGE_SNAP;
		if(m_pDlgSkin->m_hWnd == (HWND)pnmtv->itemNew.lParam)		m_iSelDialog = PROP_PAGE_SKIN;
		if(m_pDlgRemocon->m_hWnd == (HWND)pnmtv->itemNew.lParam)	m_iSelDialog = PROP_PAGE_REMOCON;
		if(m_pDlgDriver->m_hWnd == (HWND)pnmtv->itemNew.lParam)		m_iSelDialog = PROP_PAGE_DRIVER;
		if(m_pdlgPreview->m_hWnd == (HWND)pnmtv->itemNew.lParam)	m_iSelDialog = PROP_PAGE_PREVIEW;
	}

	return 0;
}

LONG CPropCfgDlg::OnTvSelChanging(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	LPNMTREEVIEW pnmtv;
	pnmtv = (LPNMTREEVIEW)lP;

	if(pnmtv->itemNew.lParam == NULL)return TRUE;

	return 0;
}

//////////////////////////////////////////////////////////////////////////////
//R}hnhnh
void CPropCfgDlg::OnOK(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	if(m_pDlgRec->m_hWnd != NULL)		SendMessage(m_pDlgRec->m_hWnd,WM_COMMAND,MAKELONG(IDOK,0),0);
	if(m_pDlgSnap->m_hWnd != NULL)		SendMessage(m_pDlgSnap->m_hWnd,WM_COMMAND,MAKELONG(IDOK,0),0);
	if(m_pDlgSkin->m_hWnd != NULL)		SendMessage(m_pDlgSkin->m_hWnd,WM_COMMAND,MAKELONG(IDOK,0),0);
	if(m_pDlgRemocon->m_hWnd != NULL)		SendMessage(m_pDlgRemocon->m_hWnd,WM_COMMAND,MAKELONG(IDOK,0),0);
	if(m_pDlgDriver->m_hWnd != NULL)		SendMessage(m_pDlgDriver->m_hWnd,WM_COMMAND,MAKELONG(IDOK,0),0);
	if(m_pdlgPreview->m_hWnd != NULL)		SendMessage(m_pdlgPreview->m_hWnd,WM_COMMAND,MAKELONG(IDOK,0),0);
}

void CPropCfgDlg::OnCancel(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){

	if(m_pDlgRec->m_hWnd != NULL)		SendMessage(m_pDlgRec->m_hWnd,WM_COMMAND,MAKELONG(IDCANCEL,0),0);
	if(m_pDlgSnap->m_hWnd != NULL)		SendMessage(m_pDlgSnap->m_hWnd,WM_COMMAND,MAKELONG(IDCANCEL,0),0);
	if(m_pDlgSkin->m_hWnd != NULL)		SendMessage(m_pDlgSkin->m_hWnd,WM_COMMAND,MAKELONG(IDCANCEL,0),0);
	if(m_pDlgRemocon->m_hWnd != NULL)		SendMessage(m_pDlgRemocon->m_hWnd,WM_COMMAND,MAKELONG(IDCANCEL,0),0);
	if(m_pDlgDriver->m_hWnd != NULL)		SendMessage(m_pDlgDriver->m_hWnd,WM_COMMAND,MAKELONG(IDCANCEL,0),0);
	if(m_pdlgPreview->m_hWnd != NULL)		SendMessage(m_pdlgPreview->m_hWnd,WM_COMMAND,MAKELONG(IDCANCEL,0),0);
}

//////////////////////////////////////////////////////////////////////////////
//bZ[Wnh
int CPropCfgDlg::OnWmInitDlg(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){

	CTreeView *pTree = NULL;
	
	TVINSERTSTRUCT tvinsert;
	HTREEITEM hTreeItem;
	HTREEITEM hTreeSel;

	//Windownh擾
	m_hWnd = hDlg;
	m_hInst = (HINSTANCE)GetWindowLong(hDlg,GWL_HINSTANCE);

	//`ChE_CAO쐬
	m_pDlgRec->m_hWnd = CreateDialogParam(m_hInst,MAKEINTRESOURCE(IDD_DLG_REC),
			hDlg,(DLGPROC)&m_pDlgRec->ProckCallBack,(LPARAM)m_pDlgRec);

	m_pDlgSnap->m_hWnd = CreateDialogParam(m_hInst,MAKEINTRESOURCE(IDD_DLG_SNAPSHOT),
			hDlg,(DLGPROC)&m_pDlgSnap->ProckCallBack,(LPARAM)m_pDlgSnap);

	m_pDlgSkin->m_hWnd = CreateDialogParam(m_hInst,MAKEINTRESOURCE(IDD_DLG_SKIN),
			hDlg,(DLGPROC)&m_pDlgSkin->ProckCallBack,(LPARAM)m_pDlgSkin);

	m_pDlgRemocon->m_hWnd = CreateDialogParam(m_hInst,MAKEINTRESOURCE(IDD_DLG_REMOCON),
			hDlg,(DLGPROC)&m_pDlgRemocon->ProckCallBack,(LPARAM)m_pDlgRemocon);

	m_pDlgDriver->m_hWnd = CreateDialogParam(m_hInst,MAKEINTRESOURCE(IDD_DLG_SKIN),
			hDlg,(DLGPROC)&m_pDlgDriver->ProckCallBack,(LPARAM)m_pDlgDriver);

	m_pdlgPreview->m_hWnd = CreateDialogParam(m_hInst,MAKEINTRESOURCE(IDD_DLG_PREVIEW),
			hDlg,(DLGPROC)&m_pdlgPreview->ProckCallBack,(LPARAM)m_pdlgPreview);

	//c[r[̐ݒsȂ
	pTree = new CTreeView;
	pTree->hWnd = GetDlgItem(hDlg,IDC_TREE_CFG);

	//----------------------------------------------------------------------
	//ڂ}(AvP[Vݒ)
	tvinsert.hParent = NULL;
	tvinsert.hInsertAfter = TVI_LAST;
	tvinsert.item.mask = TVIF_IMAGE|TVIF_PARAM|TVIF_SELECTEDIMAGE|TVIF_TEXT;
	tvinsert.item.pszText = IDS_TREE_APP_CFG;
	tvinsert.item.cchTextMax = strlen(IDS_TREE_APP_CFG);
	tvinsert.item.iImage = 0;
	tvinsert.item.iSelectedImage = 0;
	tvinsert.item.lParam = NULL;
	hTreeItem = pTree->InsertItem(&tvinsert);

	//ڂ}(^ݒ)
	tvinsert.hParent = hTreeItem;
	tvinsert.hInsertAfter = TVI_LAST;
	tvinsert.item.mask = TVIF_IMAGE|TVIF_PARAM|TVIF_SELECTEDIMAGE|TVIF_TEXT;
	tvinsert.item.pszText = IDS_TREE_REC;
	tvinsert.item.cchTextMax = strlen(IDS_TREE_REC);
	tvinsert.item.iImage = 0;
	tvinsert.item.iSelectedImage = 0;
	tvinsert.item.lParam = (LPARAM)m_pDlgRec->m_hWnd;

	hTreeSel = pTree->InsertItem(&tvinsert);
	if(m_iSelDialog == PROP_PAGE_REC)
		pTree->SelectItem(hTreeSel);

	//ڂ}(Î~ݒ)
	tvinsert.hParent = hTreeItem;
	tvinsert.hInsertAfter = TVI_LAST;
	tvinsert.item.mask = TVIF_IMAGE|TVIF_PARAM|TVIF_SELECTEDIMAGE|TVIF_TEXT;
	tvinsert.item.pszText = IDS_TREE_SNAP;
	tvinsert.item.cchTextMax = strlen(IDS_TREE_SNAP);
	tvinsert.item.iImage = 0;
	tvinsert.item.iSelectedImage = 0;
	tvinsert.item.lParam = (LPARAM)m_pDlgSnap->m_hWnd;

	hTreeSel = pTree->InsertItem(&tvinsert);
	if(m_iSelDialog == PROP_PAGE_SNAP)
		pTree->SelectItem(hTreeSel);

	//ڂ}(\ݒ)
	tvinsert.hParent = hTreeItem;
	tvinsert.hInsertAfter = TVI_LAST;
	tvinsert.item.mask = TVIF_IMAGE|TVIF_PARAM|TVIF_SELECTEDIMAGE|TVIF_TEXT;
	tvinsert.item.pszText = IDS_TREE_PREVIEW;
	tvinsert.item.cchTextMax = strlen(IDS_TREE_PREVIEW);
	tvinsert.item.iImage = 0;
	tvinsert.item.iSelectedImage = 0;
	tvinsert.item.lParam = (LPARAM)m_pdlgPreview->m_hWnd;

	hTreeSel = pTree->InsertItem(&tvinsert);
	if(m_iSelDialog == PROP_PAGE_PREVIEW)
		pTree->SelectItem(hTreeSel);

	//ڂ}(R)
	tvinsert.hParent = hTreeItem;
	tvinsert.hInsertAfter = TVI_LAST;
	tvinsert.item.mask = TVIF_IMAGE|TVIF_PARAM|TVIF_SELECTEDIMAGE|TVIF_TEXT;
	tvinsert.item.pszText = IDS_TREE_REMOCON;
	tvinsert.item.cchTextMax = strlen(IDS_TREE_REMOCON);
	tvinsert.item.iImage = 0;
	tvinsert.item.iSelectedImage = 0;
	tvinsert.item.lParam = (LPARAM)m_pDlgRemocon->m_hWnd;

	hTreeSel = pTree->InsertItem(&tvinsert);
	if(m_iSelDialog == PROP_PAGE_REMOCON)
		pTree->SelectItem(hTreeSel);

	//ڂ}(XL)
	tvinsert.hParent = hTreeItem;
	tvinsert.hInsertAfter = TVI_LAST;
	tvinsert.item.mask = TVIF_IMAGE|TVIF_PARAM|TVIF_SELECTEDIMAGE|TVIF_TEXT;
	tvinsert.item.pszText = IDS_TREE_SKIN;
	tvinsert.item.cchTextMax = strlen(IDS_TREE_SKIN);
	tvinsert.item.iImage = 0;
	tvinsert.item.iSelectedImage = 0;
	tvinsert.item.lParam = (LPARAM)m_pDlgSkin->m_hWnd;

	hTreeSel = pTree->InsertItem(&tvinsert);
	if(m_iSelDialog == PROP_PAGE_SKIN)
		pTree->SelectItem(hTreeSel);

	//ڂ}(XL)
	tvinsert.hParent = hTreeItem;
	tvinsert.hInsertAfter = TVI_LAST;
	tvinsert.item.mask = TVIF_IMAGE|TVIF_PARAM|TVIF_SELECTEDIMAGE|TVIF_TEXT;
	tvinsert.item.pszText = IDS_TREE_DRIVER;
	tvinsert.item.cchTextMax = strlen(IDS_TREE_DRIVER);
	tvinsert.item.iImage = 0;
	tvinsert.item.iSelectedImage = 0;
	tvinsert.item.lParam = (LPARAM)m_pDlgDriver->m_hWnd;

	hTreeSel = pTree->InsertItem(&tvinsert);
	if(m_iSelDialog == PROP_PAGE_DRIVER)
		pTree->SelectItem(hTreeSel);

	pTree->Expand(hTreeItem,TVE_EXPAND);

	//QƂ
	delete pTree;
	pTree = NULL;

	//`ChE_CAÖʒu𒲐
	SetWindowPos(m_pDlgRec->m_hWnd,			NULL,	172,	3,0,0,SWP_NOSIZE|SWP_NOZORDER);
	SetWindowPos(m_pDlgSnap->m_hWnd,			NULL,	172,	3,0,0,SWP_NOSIZE|SWP_NOZORDER);
	SetWindowPos(m_pDlgSkin->m_hWnd,			NULL,	172,	3,0,0,SWP_NOSIZE|SWP_NOZORDER);
	SetWindowPos(m_pDlgRemocon->m_hWnd,			NULL,	172,	3,0,0,SWP_NOSIZE|SWP_NOZORDER);
	SetWindowPos(m_pDlgDriver->m_hWnd,			NULL,	172,	3,0,0,SWP_NOSIZE|SWP_NOZORDER);
	SetWindowPos(m_pdlgPreview->m_hWnd,			NULL,	172,	3,0,0,SWP_NOSIZE|SWP_NOZORDER);

	//_CAO̕\ݒsȂ
	ShowWindow(m_pDlgRec->m_hWnd,SW_HIDE);

	switch(m_iSelDialog){
	case PROP_PAGE_REC:
	default:
		ShowWindow(m_pDlgRec->m_hWnd,SW_SHOW);
		break;
	case PROP_PAGE_SNAP:
		ShowWindow(m_pDlgSnap->m_hWnd,SW_SHOW);
		break;
	case PROP_PAGE_SKIN:
		ShowWindow(m_pDlgSkin->m_hWnd,SW_SHOW);
		break;
	case PROP_PAGE_REMOCON:
		ShowWindow(m_pDlgRemocon->m_hWnd,SW_SHOW);
		break;
	case PROP_PAGE_DRIVER:
		ShowWindow(m_pDlgDriver->m_hWnd,SW_SHOW);
		break;
	case PROP_PAGE_PREVIEW:
		ShowWindow(m_pdlgPreview->m_hWnd,SW_SHOW);
		break;
	}

	//
	if(pTree != NULL){
		pTree->hWnd = NULL;
		delete pTree;
		pTree = NULL;
	}

	return 0;
}

int CPropCfgDlg::OnWmNotify(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
	LPNMHDR lpnmhdr;
	LONG lRet = 0;

	lpnmhdr = (LPNMHDR) lP; 

	switch(lpnmhdr->idFrom){
	case IDC_TREE_CFG:
		//c[NOTIFY
		switch(lpnmhdr->code){
		case TVN_SELCHANGED:
			lRet = OnTvnSelChange(hDlg,msg,wP,lP);
			break;
		case TVN_SELCHANGING:
			lRet = OnTvSelChanging(hDlg,msg,wP,lP);
			break;
		}
		break;
	default:
		break;
	}

	return lRet;
}

int CPropCfgDlg::OnWmCommand(HWND hDlg,UINT msg,WPARAM wP,LPARAM lP){
//	int iIdx;

	switch(GET_WM_COMMAND_ID(wP,lP)){

	case IDC_BTN_OK:
		OnOK(hDlg,msg,wP,lP);
		EndDialog(hDlg,IDOK);
		break;

	case IDC_BTN_CANCEL:
		OnCancel(hDlg,msg,wP,lP);
		EndDialog(hDlg,IDCANCEL);
		break;
	}
	return 0;
}

//bZ[Wv-W[
LRESULT CPropCfgDlg::DlgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam){

	switch (uMsg){
	case WM_COMMAND:
		return OnWmCommand(hWnd,uMsg,wParam,lParam);

	case WM_INITDIALOG:
		return OnWmInitDlg(hWnd,uMsg,wParam,lParam);

	case WM_NOTIFY:
		return OnWmNotify(hWnd,uMsg,wParam,lParam);

	case WM_DESTROY:
		RemoveProp(hWnd, PTDIGI_DLG_PROP);
		break;
	}


	return 0;
}
