#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <stdio.h>
#include <io.h>
#include <math.h>
#include <time.h>

#include "CViewPlayer.h"
#include "..\Util\StrUtil.h"

#include "..\resource.h"

//////////////////////////////////////////////////////////////////////////////
//萔̒`

//////////////////////////////////////////////////////////////////////////////
//NX̎
CViewPlayer::CViewPlayer(){
	
	m_hRgn = NULL;

	m_hBmpBackBuf = NULL;
	m_hDCBackBuf = NULL;
	m_hOldBackObj = NULL;

	//IuWFNg̐ݒ
	m_pProcVolume = NULL;			//ʒ̃R[obN֐ւ̃|C^
	m_pAudioProcParam = NULL;					//R[obNɈnp[^

	//{^\p
	m_pBtnSprite = NULL;		//XvCg
	m_nBtnSpriteNum = 0;		//XvCg̐

	//V[No[p
	flagVolumeMove = FALSE;

	//vC[\(t@CA)p
	m_szInfomation[0] = '\0';//\镶
	m_hFontInfomation = NULL;//\ɎgptHg

	//c[`bvݒ
	m_flagToolTipActivate = TRUE;
	m_pToolTip = NULL;

	ZeroMemory(&m_DrawRect,sizeof(m_DrawRect));

	m_pcSetting = NULL;
	m_hInst = NULL;

	m_szSkinFolder[0] = '\0';

	m_nDrawPos = 0;
	m_nDrawMaxWidth = 0;
	m_nDrawMaxHeight = 0;
	m_nDrawInfoWidth = 0;
	m_nDrawPosWait = PLAYER_INFO_SCROLL_WAIT;
	m_nDrawInfo_LineCount = 0;
	m_nDrawInfo_RetPos = 0;

	m_hBmpInfoBuf = NULL;
	m_hDCInfoBuf = NULL;
	m_hOldInfoObj = NULL;

}


CViewPlayer::~CViewPlayer(){
	//pɎ擾
	if(m_hRgn != NULL){
		DeleteObject(m_hRgn);
		m_hRgn = NULL;
	}

	if(m_hDCBackBuf != NULL){
		if(m_hOldBackObj != NULL){
			//foCXReLXg̑ĨIuWFNgɖ߂
			SelectObject(m_hDCBackBuf,m_hOldBackObj);
			m_hOldBackObj = NULL;
		}
		DeleteDC(m_hDCBackBuf);
		m_hDCBackBuf = NULL;
	}

	if(m_hBmpBackBuf != NULL){
		DeleteObject(m_hBmpBackBuf);
		m_hBmpBackBuf = NULL;
	}

	if(m_hDCInfoBuf != NULL){
		if(m_hOldInfoObj != NULL){
			//foCXReLXg̑ĨIuWFNgɖ߂
			SelectObject(m_hDCInfoBuf,m_hOldInfoObj);
			m_hOldInfoObj = NULL;
		}
		DeleteDC(m_hDCInfoBuf);
		m_hDCInfoBuf = NULL;
	}

	if(m_hBmpInfoBuf != NULL){
		DeleteObject(m_hBmpInfoBuf);
		m_hBmpInfoBuf = NULL;
	}

	if(m_pBtnSprite != NULL){
		delete [] m_pBtnSprite;
		m_pBtnSprite = NULL;
	}
	
	if(m_hFontInfomation != NULL){
		DeleteObject(m_hFontInfomation);
	}

	if(m_pToolTip != NULL){
		delete m_pToolTip;
		m_pToolTip = NULL;
	}

}

////////////////////////////////////////////////////////////////
//p[^擾ݒɊւ鏈
//t@C/ǂƂĕ\镶ݒ肷
void CViewPlayer::SetPlayerInfo(char *pszInfo){

	PTDIGI_SKIN_PLAYER_INFO playerInfo;

	{
		//NeBJZNVŕ`揈ی삷
		CYAutoLock cObjectLock(&m_CreSec);

		if(pszInfo != NULL){
			if(strncmp(m_szInfomation,pszInfo,PLAYER_INFO_LENGTH-1) != 0){
				//`ItZbg
				m_nDrawPos = 0;
				m_nDrawPosWait = PLAYER_INFO_SCROLL_WAIT;
			}
			strncpy(m_szInfomation,pszInfo,PLAYER_INFO_LENGTH-1);
			m_szInfomation[PLAYER_INFO_LENGTH-1] = '\0';
		}
		else m_szInfomation[0]='\0';
	}


	//̍ő啝߂
	int i,j;
	int nLength;
	
	char szStr[PLAYER_INFO_LENGTH];
	HDC hdc;
	HGDIOBJ hOldObj;
	SIZE stSize;
	BOOL bIsEnd;

	nLength = strlen(m_szInfomation);
	m_nDrawMaxWidth = 0;
	m_nDrawMaxHeight = 0;
	m_nDrawInfo_RetPos = 0;
	m_nDrawInfo_LineCount = 0;

	hdc = GetDC(m_hWnd);
	hOldObj = SelectObject(hdc,m_hFontInfomation);

	for(i=0,j=0;i<nLength;++i,++j){

		szStr[j] = m_szInfomation[i];
	
		if(CheckSjis(szStr[j]) == 0){
			//Sp̏ꍇ̏
			++i;
			++j;
			szStr[j] = m_szInfomation[i];
			if(i < nLength-1)continue;
		}

		if(szStr[j] == '\0')
			bIsEnd = TRUE;
		else if(m_szInfomation[i] == '\r' && m_szInfomation[i+1] == '\n'){
			++i;
			bIsEnd = TRUE;
		}
		else if(i >= nLength-1)
			bIsEnd = TRUE;
		else bIsEnd = FALSE;

		if(bIsEnd == TRUE)
		{
			szStr[j+1] = '\0';

			ErrMsg("[Inf]CViewPlayer::SetPlayerInfo -> %d : <%s>",m_nDrawInfo_LineCount,szStr);

			if(m_nDrawInfo_RetPos == 0){
				m_nDrawInfo_RetPos = i;
			}
			
			GetTextExtentPoint32(hdc,szStr,strlen(szStr),&stSize);
			
			if(m_nDrawMaxWidth < stSize.cx)
				m_nDrawMaxWidth = stSize.cx;

			if(m_nDrawMaxHeight < stSize.cy)
				m_nDrawMaxHeight = stSize.cy;

			j = -1;

			++m_nDrawInfo_LineCount;
		}
	}

	SelectObject(hdc,hOldObj);
	ReleaseDC(m_hWnd,hdc);

	ErrMsg("[Inf]CViewPlayer::SetPlayerInfo -> %s",m_szInfomation);
	ErrMsg("[Inf]CViewPlayer::SetPlayerInfo -> ő`敝 = %d",m_nDrawMaxWidth);
	ErrMsg("[Inf]CViewPlayer::SetPlayerInfo -> m_nDrawInfo_RetPos = %d , m_nDrawInfo_LineCount = %d",m_nDrawInfo_RetPos,m_nDrawInfo_LineCount);

	ZeroMemory(&playerInfo,sizeof(PTDIGI_SKIN_PLAYER_INFO));
	m_cSkin.GetPlayerInfo(&playerInfo);

	InvalidateRect(m_hWnd,&playerInfo.rc,TRUE);
	::UpdateWindow(m_hWnd);
}

//\eꂩmF
BOOL CViewPlayer::IsSamePlayerInfo(char *pszInfo){
	//NeBJZNVŕ`揈ی삷
	CYAutoLock cObjectLock(&m_CreSec);

	if(strcmp(m_szInfomation,pszInfo) == 0)return TRUE;

	return FALSE;
}

void CViewPlayer::put_cSetting(CSetting *pSetting){
	m_pcSetting = pSetting;
}

////////////////////////////////////////////////////////////////
//XLɊւ鏈
BOOL CViewPlayer::ReadSkinData(char *pszFile){

	PTDIGI_SKIN_BUTTON			btnInfo;
	PTDIGI_SKIN_VOLUMEBAR		volumeInfo;
	PTDIGI_SKIN_PLAYER_STATUS	playerStat;
	PTDIGI_SKIN_PLAYER_INFO		playerInfo;
	PTDIGI_SKIN_PLAYER_CLOCK	clockInfo;
	PTDIGI_SKIN_MAINWND			mainWndInfo;

	int i;
	char szBmpPath[MAX_PATH];
	if(pszFile == NULL)return FALSE;
	
	//XLǂݍ
	strcpy(szBmpPath,m_szSkinFolder);
	strcat(szBmpPath,pszFile);

	if(m_cSkin.ReadSkinData(szBmpPath) == FALSE)return FALSE;

	//////////////////////////////////////////////////////////////////////////
	//XvCgǂݍ
	if(m_pBtnSprite != NULL){
		delete [] m_pBtnSprite;
		m_pBtnSprite = NULL;
		m_nBtnSpriteNum = 0;
	}

	m_nBtnSpriteNum = m_cSkin.GetBtnNum();
	m_pBtnSprite = new PTDIGI_BUTTON[m_nBtnSpriteNum];

	for(i=0;i<m_nBtnSpriteNum;++i){
		m_cSkin.GetBtnInfo(i,&btnInfo);
		ReadBtnBmp(m_szSkinFolder,&btnInfo,&m_pBtnSprite[i]);
		if(btnInfo.nFunction == PTDIGI_FUNC_MuteOff)
		{	// ݒŁA~[gԂ̃{^͔\Ƃ
			m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_NO_VISIBLE;
		}
	}
	
	//////////////////////////////////////////////////////////////////////////
	//gp̃tHg
	if(m_hFontInfomation != NULL){
		DeleteObject(m_hFontInfomation);
		m_hFontInfomation = NULL;
	}

	//////////////////////////////////////////////////////////////////////////
	//{[o[̏ǂݍ
	ZeroMemory(&volumeInfo,sizeof(PTDIGI_SKIN_VOLUMEBAR));
	m_cSkin.GetVolumeInfo(&volumeInfo);
	if(volumeInfo.pszBmpDefault != NULL){
		szBmpPath[0] = '\0';
		if(m_szSkinFolder != NULL)strcpy(szBmpPath,m_szSkinFolder);
		strcat(szBmpPath,volumeInfo.pszBmpDefault);
		m_VolumeSprite.Defautl.CreateSpriteFromFile(szBmpPath,PTDIGI_TRANSPARENT_COLOR);
	}

	if(volumeInfo.pszBmpSelect != NULL){
		szBmpPath[0] = '\0';
		if(m_szSkinFolder != NULL)strcpy(szBmpPath,m_szSkinFolder);
		strcat(szBmpPath,volumeInfo.pszBmpSelect);
		m_VolumeSprite.Select.CreateSpriteFromFile(szBmpPath,PTDIGI_TRANSPARENT_COLOR);
	}

	if(volumeInfo.pszBmpMute != NULL){
		szBmpPath[0] = '\0';
		if(m_szSkinFolder != NULL)strcpy(szBmpPath,m_szSkinFolder);
		strcat(szBmpPath,volumeInfo.pszBmpMute);
		m_VolumeSprite.Mute.CreateSpriteFromFile(szBmpPath,PTDIGI_TRANSPARENT_COLOR);
	}


	//////////////////////////////////////////////////////////////////////////
	//vC[\()p̏ǂݍ
	ZeroMemory(&playerStat,sizeof(PTDIGI_SKIN_PLAYER_STATUS));
	m_cSkin.GetPlayerStatInfo(&playerStat);

	if(playerStat.pszBmpTVWatch != NULL){
		szBmpPath[0] = '\0';
		if(m_szSkinFolder != NULL)strcpy(szBmpPath,m_szSkinFolder);
		strcat(szBmpPath,playerStat.pszBmpTVWatch);
		m_PlayerStatSprite.TVWatch.CreateSpriteFromFile(szBmpPath,PTDIGI_TRANSPARENT_COLOR);
	}

	if(playerStat.pszBmpRecord != NULL){
		szBmpPath[0] = '\0';
		if(m_szSkinFolder != NULL)strcpy(szBmpPath,m_szSkinFolder);
		strcat(szBmpPath,playerStat.pszBmpRecord);
		m_PlayerStatSprite.Record.CreateSpriteFromFile(szBmpPath,PTDIGI_TRANSPARENT_COLOR);
	}

	//////////////////////////////////////////////////////////////////////////
	//vC[\(t@CA)p̏ǂݍ
	ZeroMemory(&playerInfo,sizeof(PTDIGI_SKIN_PLAYER_INFO));
	m_cSkin.GetPlayerInfo(&playerInfo);

	m_hFontInfomation = CreateFontFromSkinFont(&playerInfo.stFont);

	m_nDrawInfoWidth = playerInfo.rc.right - playerInfo.rc.left;

	//////////////////////////////////////////////////////////////////////////
	//vC[\()p̏ǂݍ
	ZeroMemory(&clockInfo,sizeof(PTDIGI_SKIN_PLAYER_CLOCK));
	m_cSkin.GetClockInfo(&clockInfo);
	for(i=0;i<10;++i){
		if( clockInfo.pszBmpNum[i] != NULL){
			szBmpPath[0] = '\0';
			if(m_szSkinFolder != NULL)strcpy(szBmpPath,m_szSkinFolder);
			strcat(szBmpPath,clockInfo.pszBmpNum[i]);
			m_ClockSprite.Number[i].CreateSpriteFromFile(szBmpPath,PTDIGI_TRANSPARENT_COLOR);
		}
	}

	if( clockInfo.pszBmpCoron != NULL){
		szBmpPath[0] = '\0';
		if(m_szSkinFolder != NULL)strcpy(szBmpPath,m_szSkinFolder);
		strcat(szBmpPath,clockInfo.pszBmpCoron);
		m_ClockSprite.Colon.CreateSpriteFromFile(szBmpPath,PTDIGI_TRANSPARENT_COLOR);
	}


	//////////////////////////////////////////////////////////////////////////
	//wȉǂݍ
	ZeroMemory(&mainWndInfo,sizeof(PTDIGI_SKIN_MAINWND));
	m_cSkin.GetMainWndInfo(&mainWndInfo);
	if(mainWndInfo.pszBmpBack != NULL){
		szBmpPath[0] = '\0';
		if(m_szSkinFolder != NULL)strcpy(szBmpPath,m_szSkinFolder);
		strcat(szBmpPath,mainWndInfo.pszBmpBack);
		m_BackGroundSprite.Main.CreateSpriteFromFile(szBmpPath,PTDIGI_TRANSPARENT_COLOR);
	}
	else m_BackGroundSprite.Main.Release();

	//////////////////////////////////////////////////////////////////////////
	//c[`bvݒ肷
	SetTooltipRect();

	//////////////////////////////////////////////////////////////////////////
	//`obt@쐬
	CreateBackBuffer();

	return TRUE;
}

//ǂݍ񂾃rbg}bv
void CViewPlayer::ReleaseSprite(void){
	
	//{^
	if(m_pBtnSprite != NULL){
		delete [] m_pBtnSprite;
		m_pBtnSprite = NULL;
		m_nBtnSpriteNum = 0;
	}

	//{[o[
	m_VolumeSprite.Defautl.Release();
	m_VolumeSprite.Select.Release();
	m_VolumeSprite.Mute.Release();

	//vC[̏\()p
	m_PlayerStatSprite.Play.Release();
	m_PlayerStatSprite.Pause.Release();
	m_PlayerStatSprite.Record.Release();
	m_PlayerStatSprite.Stop.Release();
	m_PlayerStatSprite.Forward.Release();
	m_PlayerStatSprite.Back.Release();
	m_PlayerStatSprite.TVWatch.Release();

	//vC[(v)p
	m_ClockSprite.Number[0].Release();
	m_ClockSprite.Number[1].Release();
	m_ClockSprite.Number[2].Release();
	m_ClockSprite.Number[3].Release();
	m_ClockSprite.Number[4].Release();
	m_ClockSprite.Number[5].Release();
	m_ClockSprite.Number[6].Release();
	m_ClockSprite.Number[7].Release();
	m_ClockSprite.Number[8].Release();
	m_ClockSprite.Number[9].Release();
	m_ClockSprite.Colon.Release();

	//wi̊Gp
	m_BackGroundSprite.Main.Release();
}

#ifdef _LAYER_WND_
//////////////////////////////////////////////////////////////////////////////
//C[EChE
BOOL CViewPlayer::SetAlphaColor(COLORREF col,BYTE bAlpha,DWORD dwFlags){
	
	if(m_hWnd == NULL)return FALSE;
	if(lpSetLayeredWindowAttributes == NULL)return FALSE;
	
	return lpSetLayeredWindowAttributes(m_hWnd,col,bAlpha,dwFlags);
}
#endif

//////////////////////////////////////////////////////////////////////////////
//`ʒuvZp̊֐
//XW̕`ItZbgvZ
//:pRc->`͈
//߂l:xWItZbg
int CViewPlayer::Calculate_DrawX(RECT *pRc){
	//Cʂ`悷ʒu߂
	return  (((pRc->right - pRc->left) - m_BackGroundSprite.Main.GetWidth()) / 2) + m_DrawRect.left;
}

//////////////////////////////////////////////////////////////////////////////
//XLf[^gpĕ`悷
BOOL CViewPlayer::Draw_Text(HDC hdc,HFONT hFont,char *pszText,PTDIGI_SKIN_FONT *pFont,RECT *pRect){
	HGDIOBJ hObj = NULL;
	COLORREF colOld,colOldBk;
	int nOldBkMode;

	if(hFont != NULL)
		hObj = SelectObject(hdc,hFont);

	if(pFont->nTransparent == 0){
		//ߏȂꍇ
		nOldBkMode = SetBkMode(hdc,OPAQUE);
		colOldBk = SetBkColor(hdc, RGB(pFont->backColor.rgbRed,
							pFont->backColor.rgbGreen,
							pFont->backColor.rgbBlue));
	}
	else{
		//ߏsꍇ
		nOldBkMode = SetBkMode(hdc,TRANSPARENT);
	}

	colOld = SetTextColor(hdc, RGB(	pFont->textColor.rgbRed,
							pFont->textColor.rgbGreen,
							pFont->textColor.rgbBlue));

	//`悷
	DrawText(hdc,pszText,-1,pRect,DT_NOPREFIX|DT_LEFT|DT_WORDBREAK|DT_EDITCONTROL);

	SetTextColor(hdc,colOld);
	SetBkMode(hdc,nOldBkMode);
	if(pFont->nTransparent == 0){
		SetBkColor(hdc,colOldBk);
	}

	if(hObj != NULL)
		SelectObject(hdc,hObj);

	return TRUE;
}
//////////////////////////////////////////////////////////////////////////////
//Ȏ֐
////////////////////////////////////////////////////////////////
//S{^`悷(NX̊O{^ĕ`悷鎞Ɏgp)
//:Ȃ
//߂l Ȃ
void CViewPlayer::DrawButton(void){
	PTDIGI_BUTTON btnInfo;
	if(m_hWnd == NULL) return;
	HDC hdc = GetDC(m_hWnd);

	DrawButton(hdc,Calculate_DrawX(&m_DrawRect),m_DrawRect.top);

	ReleaseDC(m_hWnd,hdc);
}

////////////////////////////////////////////////////////////////
//{[`悷
//:Ȃ
//߂l Ȃ
void CViewPlayer::DrawVolume(long lVolume){
	if(m_hWnd == NULL)return;
	HDC hdc = GetDC(m_hWnd);
	DrawVolume(hdc,Calculate_DrawX(&m_DrawRect),m_DrawRect.top,lVolume);
	ReleaseDC(m_hWnd,hdc);
}

////////////////////////////////////////////////////////////////
//vC[̏`悷
//:Ȃ
//߂l Ȃ
void CViewPlayer::DrawPlayerStat(int nAppStat){
	
	if(m_hWnd == NULL){
		return;
	}
	HDC hdc = GetDC(m_hWnd);
	DrawPlayerStat(hdc,Calculate_DrawX(&m_DrawRect),m_DrawRect.top,nAppStat);
	ReleaseDC(m_hWnd,hdc);
}

////////////////////////////////////////////////////////////////
//vC[̏(t@CA)`悷
//:Ȃ
//߂l Ȃ
void CViewPlayer::DrawPlayerInfo(void){
	if(m_hWnd == NULL)return;
	HDC hdc = GetDC(m_hWnd);
	DrawPlayerInfo(hdc,Calculate_DrawX(&m_DrawRect),m_DrawRect.top);
	ReleaseDC(m_hWnd,hdc);
}

////////////////////////////////////////////////////////////////
//vC[̏()`悷
//:Ȃ
//߂l Ȃ
void CViewPlayer::DrawClock(int nTime){
	int nWidth,nHeight;
	PTDIGI_SKIN_PLAYER_CLOCK Info;


	if(m_hWnd == NULL)return;
	if(m_DrawRect.bottom == 0 && m_DrawRect.left == 0 &&
		m_DrawRect.right == 0 && m_DrawRect.top == 0)return;
	
	DrawClock(m_hDCBackBuf,0,0,nTime);

	HDC hdc = GetDC(m_hWnd);

	nWidth = m_ClockSprite.Number[0].GetWidth() * 6 + m_ClockSprite.Colon.GetWidth() * 2;
	nHeight = m_ClockSprite.Number[0].GetHeight();

	m_cSkin.GetClockInfo(&Info);

	BitBlt(hdc,
		Calculate_DrawX(&m_DrawRect) + Info.nX,
		m_DrawRect.top + Info.nY,
		nWidth,nHeight,
		m_hDCBackBuf,
		Info.nX,Info.nY,SRCCOPY);


	ReleaseDC(m_hWnd,hdc);
}

////////////////////////////////////////////////////////////////
//\XV
//:fPos -> V[Nʒu
//     fLength -> Đt@C̒
//     lVolume -> ݂̃{[(0`100)
//     bIsMute -> ~[g̏
//     nAppStat -> AvP[ṼXe[^X
//     nPlayerStat -> vC[̃Xe[^X
//     nTime -> \鎞(b)
//     pszFmt -> tH[}bg̕
//߂l Ȃ
/*void CViewPlayer::DrawAll(HDC hdc ,RECT rcBackDraw,
						  double fPos,double fLength,
							long lVolume, BOOL bIsMute, 
							int nAppStat, int nPlayerStat,
							BOOL bIsCapPre,BOOL bIsCapRec,
						  int nTime,
						  char *pszFmt,
						  int nAudioRate){*/
void CViewPlayer::DrawAll(HDC hdc ,RECT rcBackDraw,ST_CV_PLY_FUNC_PARAM *pParam){

	RECT rc;

	if(m_DrawRect.bottom == 0 && m_DrawRect.left == 0 &&
		m_DrawRect.right == 0 && m_DrawRect.top == 0)return;

	ErrMsg("[Inf]CViewPlayer::DrawAll : Start");

	//////////////////////////////////////////////////////////////////////////
	//{^̏ԂM
	CheckButtonStat(pParam);

	//////////////////////////////////////////////////////////////////////////
	//wi̕`
	int nDrawX;

	rc.left = 0;
	rc.right = rcBackDraw.right - rcBackDraw.left;
	rc.top = 0;
	rc.bottom = rcBackDraw.bottom - rcBackDraw.top;

	nDrawX = Calculate_DrawX(&m_DrawRect) - rcBackDraw.left;

	DrawBackGround(m_hDCBackBuf,0,0,&rc);
	DrawButton(m_hDCBackBuf,nDrawX,0);
	DrawVolume(m_hDCBackBuf,nDrawX,0,pParam->lVolume);

	DrawPlayerStat(m_hDCBackBuf,nDrawX,0,pParam->nAppStat);
	DrawPlayerInfo(m_hDCBackBuf,nDrawX,0);
	DrawClock(m_hDCBackBuf,nDrawX,0,pParam->nTime);

	BitBlt(hdc,m_DrawRect.left,
				m_DrawRect.top,
			m_DrawRect.right - m_DrawRect.left,
			m_DrawRect.bottom - m_DrawRect.top - 1,
			m_hDCBackBuf,
			0,0,
			SRCCOPY);

	ErrMsg("[Inf]CViewPlayer::DrawAll : End");
}

////////////////////////////////////////////////////////////////
//po֐

////////////////////////////////////////////////////////////////
//w肵{^`悷
//:hdc -> `̃foCXReLXg
//		iNum -> `悷{^ԍ
//     iStyle -> `悷
//     fForce -> `tO(TRUE K㏑AFALSE@ԂłΏ㏑Ȃ)
//߂l 0 s
//       ȊO
int CViewPlayer::DrawButton(HDC hdc ,int x, int y, int iNum ,int iStyle, BOOL fForce){

	//NeBJZNVŕ`揈ی삷
	//CYAutoLock cObjectLock(&m_CreSec);

	PTDIGI_SKIN_BUTTON btnInfo;

	if(iNum < 0 && iNum >= m_nBtnSpriteNum) return 0;
	if(m_DrawRect.bottom == 0 && m_DrawRect.left == 0 &&
		m_DrawRect.right == 0 && m_DrawRect.top == 0)return 1;

	// \Ԃ̏ꍇɂ́AȂ
	if( m_pBtnSprite[iNum].nCurrentStyle == PT_BTN_STYLE_NO_VISIBLE) return 1;

	if(m_pBtnSprite[iNum].nCurrentStyle == iStyle && fForce == FALSE) return 1;

	m_pBtnSprite[iNum].nCurrentStyle = iStyle;
	m_cSkin.GetBtnInfo(iNum,&btnInfo);

	//nBtnX = Calculate_DrawX(&m_DrawRect);
	
	switch(iStyle){
	case PT_BTN_STYLE_DEFAULT:
		m_pBtnSprite[iNum].Defautl.Draw(hdc,x + btnInfo.nX,y + btnInfo.nY);
		break;
	case PT_BTN_STYLE_DISABLE:
		m_pBtnSprite[iNum].Disable.Draw(hdc,x + btnInfo.nX,y + btnInfo.nY);
		break;
	case PT_BTN_STYLE_SELECT:
		m_pBtnSprite[iNum].Select.Draw(hdc,x + btnInfo.nX,y + btnInfo.nY);
		break;
	case PT_BTN_STYLE_PUSH:
		m_pBtnSprite[iNum].Push.Draw(hdc,x + btnInfo.nX,y + btnInfo.nY);
		break;
	}

	return 1;
}

////////////////////////////////////////////////////////////////
//S{^`悷(Ŏgp)
//:Ȃ
//߂l Ȃ
void CViewPlayer::DrawButton(HDC hdc,int x,int y){
	PTDIGI_SKIN_BUTTON btnInfo;
	int i;

	//////////////////////////////////////////////////////////////////////////
	//{^̕`
	for(i=0;i<m_nBtnSpriteNum;++i){
		m_cSkin.GetBtnInfo(i,&btnInfo);
		DrawButton(hdc,x,y,i,m_pBtnSprite[i].nCurrentStyle,TRUE);//{^ĕ`悷
	}
}

////////////////////////////////////////////////////////////////
//ʒo[`悷
//hdc -> `Ώۂ̃foCXReLXg
//x,y -> `W
//lVolume -> {[ 0`100
int CViewPlayer::DrawVolume(HDC hdc,int x,int y, long lVolume){

	if(m_DrawRect.bottom == 0 && m_DrawRect.left == 0 &&
		m_DrawRect.right == 0 && m_DrawRect.top == 0)return 1;

	PTDIGI_SKIN_VOLUMEBAR volumeInfo;
	m_cSkin.GetVolumeInfo(&volumeInfo);

	x += volumeInfo.nX;
	y += volumeInfo.nY;

	if(m_VolumeSprite.Defautl.GetWidth() <= 0)return 0;
	if(m_VolumeSprite.Defautl.GetHeight() <= 0)return 0;

	int iWidth;
	int iWidth_Sel;
	RECT rc;

	iWidth = m_VolumeSprite.Defautl.GetWidth();

	iWidth_Sel = 0;

	rc.top = y;
	rc.bottom = y + m_VolumeSprite.Defautl.GetHeight();
	
	BOOL bIsMute;

	if(m_pcSetting != NULL)
		bIsMute = m_pcSetting->get_IsMute();
	else
		bIsMute = FALSE;

	//I͈͂`悷

	if(lVolume > 100)lVolume = 100;
	if(lVolume < 0)lVolume = 0;
	
	iWidth_Sel = iWidth * lVolume / 100;
	rc.left = x;
	rc.right = x + iWidth_Sel;

	//̈␳
	//rc.left += x;
	//rc.right += x;

	if(bIsMute == TRUE){
		m_VolumeSprite.Mute.Draw(hdc,x,y,rc);
	}
	else{
		m_VolumeSprite.Select.Draw(hdc,x,y,rc);
	}

	//I͈͂`悷
	rc.left = x + iWidth_Sel + iWidth_Sel;// + x;
	rc.right = x + iWidth;// + x;
	m_VolumeSprite.Defautl.Draw(hdc,x+iWidth_Sel,y,rc);

	return 1;

}

//{[o[̗̈擾
//:̈擾`
void CViewPlayer::GetVolumeRect(RECT *rc){
	
	//擾
	PTDIGI_SKIN_VOLUMEBAR volumeInfo;
	m_cSkin.GetVolumeInfo(&volumeInfo);
	
	//̈߂
	rc->left = volumeInfo.nX;
	rc->top = volumeInfo.nY;
	rc->right = volumeInfo.nX + m_VolumeSprite.Defautl.GetWidth();
	rc->bottom = volumeInfo.nY + m_VolumeSprite.Defautl.GetHeight();
}

/////////////////////////////////////////////////////////////////////
//{[o[̕`֐
//{[̈ʒu(0`100)Ԃ
int CViewPlayer::GetVolumePosFromeVolumeBar(POINT point){
	
	int iPos=0;
	RECT rc;

	GetVolumeRect(&rc);

	iPos = ((point.x - rc.left) * 100 ) / (rc.right - rc.left);

	ErrMsg("[Inf]GetVolumePosFromeVolumeBar -> iPos=%d",iPos);

	if(iPos < 0)iPos = 0;
	if(iPos > 100)iPos = 100;


	return iPos;
}

/////////////////////////////////////////////////////////////////////
//vC[̏̕`
//:hdc -> `̃foCXReLXg
//߂l: 0 -> s(~\)
//        1 -> 
int CViewPlayer::DrawPlayerStat(HDC hdc,int x, int y, int nAppStat){

	if(m_DrawRect.bottom == 0 && m_DrawRect.left == 0 &&
		m_DrawRect.right == 0 && m_DrawRect.top == 0)return 1;

	PTDIGI_SKIN_PLAYER_STATUS plstatInfo;
	m_cSkin.GetPlayerStatInfo(&plstatInfo);
	
	//擾
	switch(nAppStat){
	case VIEW_STATUS_TV_PREVIEW:		//TV
	default:
		m_PlayerStatSprite.TVWatch.Draw(hdc,x + plstatInfo.nX,y + plstatInfo.nY);
		break;
	case VIEW_STATUS_TV_RECORD:		//TV^撆
		m_PlayerStatSprite.Record.Draw(hdc,x + plstatInfo.nX,y + plstatInfo.nY);
		break;
	}

	return 1;
}

/////////////////////////////////////////////////////////////////////
//vC[̏(t@C/ǖ)̕`
//:hdc -> `̃foCXReLXg
//߂l: 0 -> s(~\)
//        1 -> 
int CViewPlayer::DrawPlayerInfo(HDC hdc,int x, int y){
	//NeBJZNVŕ`揈ی삷
	CYAutoLock cObjectLock(&m_CreSec);

	if(m_DrawRect.bottom == 0 && m_DrawRect.left == 0 &&
		m_DrawRect.right == 0 && m_DrawRect.top == 0)return 1;

	PTDIGI_SKIN_PLAYER_INFO playerInfo;

	ZeroMemory(&playerInfo,sizeof(PTDIGI_SKIN_PLAYER_INFO));
	m_cSkin.GetPlayerInfo(&playerInfo);

#if 0
	m_BackGroundSprite.Main.DrawPart(hdc,
		playerInfo.rc.left + x,
		playerInfo.rc.top + y,
		playerInfo.rc);

#endif
	m_BackGroundSprite.Main.DrawPart(m_hDCInfoBuf,
		0,
		0,
		playerInfo.rc);

	playerInfo.rc.left += x;
	playerInfo.rc.right += x;
	playerInfo.rc.bottom += y;
	playerInfo.rc.top += y;


	RECT rc;
	char szStr[64];
	int nWidth,nHeight;

	nWidth = playerInfo.rc.right - playerInfo.rc.left;
	nHeight = playerInfo.rc.bottom - playerInfo.rc.top;

	if(m_nDrawInfo_LineCount > 1 && m_nDrawInfo_RetPos != 0 && m_nDrawInfo_RetPos < 64){
		CopyMemory(szStr,m_szInfomation,m_nDrawInfo_RetPos);
		szStr[m_nDrawInfo_RetPos] = '\0';

		rc.top = 0;
		rc.bottom = m_nDrawMaxHeight;
		rc.left = 0;
		rc.right = m_nDrawMaxWidth;
		
		Draw_Text(m_hDCInfoBuf,m_hFontInfomation,&szStr[0],&playerInfo.stFont,&rc);

		rc.top = 0;//m_nDrawMaxHeight+1;
		rc.bottom = nHeight;
		rc.left = 0;
		if(m_nDrawMaxWidth > nWidth)
			rc.left = rc.left - m_nDrawPos;
		rc.right = m_nDrawMaxWidth;
		Draw_Text(m_hDCInfoBuf,m_hFontInfomation,&m_szInfomation[m_nDrawInfo_RetPos],&playerInfo.stFont,&rc);

	}
	else{
		rc.top = 0;
		rc.bottom = nHeight;
		rc.left = 0;
		if(m_nDrawMaxWidth > nWidth)
			rc.left = rc.left - m_nDrawPos;
		rc.right = m_nDrawMaxWidth;
		Draw_Text(m_hDCInfoBuf,m_hFontInfomation,&m_szInfomation[0],&playerInfo.stFont,&rc);
	}

	BitBlt(hdc,
		playerInfo.rc.left,playerInfo.rc.top,
		nWidth,nHeight,
		m_hDCInfoBuf,0,0,SRCCOPY);


	return 1;
}

/////////////////////////////////////////////////////////////////////
//vC[̏(t@C/ǖ)̕`
//:hdc -> `̃foCXReLXg
//     nTime -> \鎞(b)
//߂l: 0 -> s(~\)
//        1 -> 
int CViewPlayer::DrawClock(HDC hdc, int x, int y, int nTime){
	
	int iDrawType = 0;
	int iHour,iMinute,iSec;
	int iNum;

	if(m_DrawRect.bottom == 0 && m_DrawRect.left == 0 &&
		m_DrawRect.right == 0 && m_DrawRect.top == 0)return 1;

	iHour = nTime / 3600;
	iMinute = nTime % 3600;
	iSec = iMinute % 60;
	iMinute = iMinute / 60;
	
	//ԕ␳
	if(iHour > 99)iHour = 99;

	//擾
	PTDIGI_SKIN_PLAYER_CLOCK Info;
	int iX;
	m_cSkin.GetClockInfo(&Info);

	iX = Info.nX + x;
	Info.nY += y;

	//Ԃ`悷
	//
	iNum = iHour / 10;
	m_ClockSprite.Number[iNum].Draw(hdc,iX,Info.nY);

	iX += m_ClockSprite.Number[iNum].GetWidth();
	iNum = iHour % 10;
	m_ClockSprite.Number[iNum].Draw(hdc,iX,Info.nY);

	//":"
	iX += m_ClockSprite.Number[iNum].GetWidth();
	m_ClockSprite.Colon.Draw(hdc,iX,Info.nY);

	//
	iX += m_ClockSprite.Colon.GetWidth();
	iNum = iMinute / 10;
	m_ClockSprite.Number[iNum].Draw(hdc,iX,Info.nY);

	iX += m_ClockSprite.Number[iNum].GetWidth();
	iNum = iMinute % 10;
	m_ClockSprite.Number[iNum].Draw(hdc,iX,Info.nY);

	//":"
	iX += m_ClockSprite.Number[iNum].GetWidth();
	m_ClockSprite.Colon.Draw(hdc,iX,Info.nY);

	//b
	iX += m_ClockSprite.Colon.GetWidth();
	iNum = iSec / 10;
	m_ClockSprite.Number[iNum].Draw(hdc,iX,Info.nY);

	iX += m_ClockSprite.Number[iNum].GetWidth();
	iNum = iSec % 10;
	m_ClockSprite.Number[iNum].Draw(hdc,iX,Info.nY);

	return 1;
}

////////////////////////////////////////////////////////////////
//wi`悷
//:hdc -> `̃foCXReLXg
//߂l: 0 -> s
//        1 -> 
int CViewPlayer::DrawBackGround(HDC hdc,int x,int y,RECT *pRc){

	if(m_DrawRect.bottom == 0 && m_DrawRect.left == 0 &&
		m_DrawRect.right == 0 && m_DrawRect.top == 0)return 1;


	//C̔wi`悷
	m_BackGroundSprite.Main.Draw(hdc,x,y,*pRc);

	return 1;
}

////////////////////////////////////////////////////////////////
//w肵WɃ{^AV[No[Ȃǂ̃Rg[邩mF
//:xy@->mFNCAgW
//߂l: TRUE ̍Wɂ̓Rg[
//        FALSE ̍Wɂ̓Rg[Ȃ
BOOL CViewPlayer::IsButton(int xPos,int yPos,int *pStyle){

	//ꂽʒũ{^̏ԂύX
	int i;
	PTDIGI_SKIN_BUTTON btnInfo;		//{^i[p
	int iX,iY;						//{^̍W
	int nBtnX;

	//V[No[p̕ϐ
	RECT rc;

	nBtnX = Calculate_DrawX(&m_DrawRect);

	//J[\̉Ƀ{[邩mF
	GetVolumeRect(&rc);
	if(xPos >= rc.left + nBtnX && xPos <= rc.right + nBtnX
		&& yPos >= rc.top + m_DrawRect.top && yPos <= rc.bottom + m_DrawRect.top){
		return TRUE;
	}

	//J[\Ƀ{^邩mF
	for(i=0;i<m_nBtnSpriteNum;++i){
		m_cSkin.GetBtnInfo(i,&btnInfo);
		iX = xPos - btnInfo.nX - nBtnX;
		iY = yPos - btnInfo.nY - m_DrawRect.top;
		if(m_pBtnSprite[i].Defautl.IsExist(iX,iY) == TRUE ){
			if(pStyle != NULL){
				*pStyle = m_pBtnSprite[i].nCurrentStyle;
			}
			return TRUE;
		}
	}

	return FALSE;
}

/////////////////////////////////////////////////////////////////////
//ǂݍ񂾃XLf[^烊[W쐬Kp
//:Ȃ
//߂l:TRUE FALSE s
BOOL CViewPlayer::SetWindowForm(void){
	if(m_hWnd == NULL)return FALSE;
	return SetWindowForm(m_hWnd,&m_BackGroundSprite.Main,RGB(0,0,255));
}

/////////////////////////////////////////////////////////////////////
//BITMAP烊[W쐬Ǎ`֐
//:hW [WKpEChEnh
//     pSprite -> [W쐬錳摜
//     colTransparent -> 쐬Ɏgp铧ߐF
//߂l:TRUE FALSE s
BOOL CViewPlayer::SetWindowForm(HWND hW,CSprite *pSprite,COLORREF colTransparent)
{

	RECT rectWindow;

	POINT ptRgn[4];
	BOOL bFound = FALSE;
	DWORD dwPixel;
	int iX = 0;
	int iY = 0;
	int iTop;
	SIZE szBmp;
	HRGN m_hNewRgn = NULL;

	if(pSprite->GetHeight() <= 0)return FALSE;
	if (hW == NULL) return FALSE;
	
	if(m_hRgn != NULL){
		DeleteObject(m_hRgn);
		m_hRgn = NULL;
	}

	//rbg}bv̍ƕ𓾂
	szBmp.cx = pSprite->GetWidth();
	szBmp.cy = pSprite->GetHeight();

	//WindowTCYrbg}bvɍ킹
	SetWindowPos(hW,NULL,0,0,szBmp.cx,
		szBmp.cy,SWP_NOMOVE|SWP_NOZORDER);

	//̃TCY擾
	GetWindowRect(hW, &rectWindow);
	iTop = rectWindow.bottom - rectWindow.top;
	
	// x[XƂȂ郊[W쐬
	for (iY = 0; iY < szBmp.cy && m_hRgn == NULL; iY++) {
		bFound = FALSE;
		for (iX = 0; iX < szBmp.cx ; iX++) {
			dwPixel = pSprite->GetPixelColor(iX,iY);//GetPixel(hdcBitmap, iX, iY);
			if (dwPixel != colTransparent) {
				if (bFound == FALSE) { // 񓧉ߐFJn_̕ۑƃXLbv
					bFound = TRUE;
					ptRgn[0].x = iX;
					//ptRgn[0].y = iTop - iY;
					ptRgn[0].y = iY;
					ErrMsg("[inf]SetWindowForm Jnʒu:(%d,%d)",iX,iY);
				}
				else{
					if(iX == szBmp.cx-1){
						ErrMsg("[inf]SetWindowForm Iʒu:(%d,%d)",iX,iY);
						ptRgn[1].x = iX;
						//ptRgn[1].y = iTop - iY;
						ptRgn[1].y = iY;
						ptRgn[2].x = iX;
						//ptRgn[2].y = iTop - iY - 1;
						ptRgn[2].y = iY + 1;
						ptRgn[3].x = ptRgn[0].x;
						ptRgn[3].y = ptRgn[0].y;// - 1;

						if(m_hRgn == NULL){
							m_hRgn = CreatePolygonRgn(ptRgn, 4, WINDING);
						}
						else{
							m_hNewRgn = CreatePolygonRgn(ptRgn, 4, WINDING);
							CombineRgn(m_hRgn, m_hRgn, m_hNewRgn, RGN_OR);
							DeleteObject(m_hNewRgn);
						}

						bFound = FALSE;
					}
				}
			}
			else {
				if (bFound==TRUE) { // ߕ̃XLbvƃ[W쐬
					ErrMsg("[inf]SetWindowForm Iʒu:(%d,%d)",iX,iY);
					ptRgn[1].x = iX;
					//ptRgn[1].y = iTop - iY;
					ptRgn[1].y = iY;
					ptRgn[2].x = iX;
					//ptRgn[2].y = iTop - iY - 1;
					ptRgn[2].y = iY + 1;
					ptRgn[3].x = ptRgn[0].x;
					ptRgn[3].y = ptRgn[0].y;// - 1;

					if(m_hRgn == NULL){
						m_hRgn = CreatePolygonRgn(ptRgn, 4, WINDING);
					}
					else{
						m_hNewRgn = CreatePolygonRgn(ptRgn, 4, WINDING);
						CombineRgn(m_hRgn, m_hRgn, m_hNewRgn, RGN_OR);
						DeleteObject(m_hNewRgn);
					}

					bFound = FALSE;
				}
			}
		}
	}

	// x[X̃[Wփ[WǉĂ
	for (; iY < szBmp.cy; iY++) {
		
		bFound = FALSE;

		for (iX = 0; iX < szBmp.cx; iX++) {
			dwPixel = pSprite->GetPixelColor(iX,iY);//GetPixel(hdcBitmap, iX, iY);
			if (dwPixel != colTransparent) {
				if (bFound == FALSE) { // 񓧉ߐFJn_̕ۑƃXLbv
					bFound = TRUE;
					ptRgn[0].x = iX;
					//ptRgn[0].y = iTop - iY;
					ptRgn[0].y = iY;
				}
				else{
					if(iX == szBmp.cx-1){
						ptRgn[1].x = iX;
						//ptRgn[1].y = iTop - iY;
						ptRgn[1].y = iY;
						ptRgn[2].x = iX;
						//ptRgn[2].y = iTop - iY - 1;
						ptRgn[2].y = iY + 1;
						ptRgn[3].x = ptRgn[0].x;
						ptRgn[3].y = ptRgn[0].y;// - 1;
						m_hNewRgn = CreatePolygonRgn(ptRgn, 4, WINDING);
						CombineRgn(m_hRgn, m_hRgn, m_hNewRgn, RGN_OR);
						DeleteObject(m_hNewRgn);
						bFound = FALSE;
					}
				}
			}
			else {
				if (bFound) { // ߕ̃XLbvƃ[W
					ptRgn[1].x = iX;
					//ptRgn[1].y = iTop - iY;
					ptRgn[1].y = iY;
					ptRgn[2].x = iX;
					//ptRgn[2].y = iTop - iY - 1;
					ptRgn[2].y = iY + 1;
					ptRgn[3].x = ptRgn[0].x;
					ptRgn[3].y = ptRgn[0].y;// - 1;
					m_hNewRgn = CreatePolygonRgn(ptRgn, 4, WINDING);
					CombineRgn(m_hRgn, m_hRgn, m_hNewRgn, RGN_OR);
					DeleteObject(m_hNewRgn);
					bFound = FALSE;
				}
			}
		}
	}
	
	// ŏIsNZ܂bFoundtruȅꍇ̃[W
	if (bFound) {
		ptRgn[1].x = iX;
		//ptRgn[1].y = iTop - iY;
		ptRgn[1].y = iY;
		ptRgn[2].x = iX;
		//ptRgn[2].y = iTop - iY - 1;
		ptRgn[2].y = iY + 1;
		ptRgn[3].x = ptRgn[0].x;
		ptRgn[3].y = ptRgn[0].y;// - 1;
		m_hNewRgn = CreatePolygonRgn(ptRgn, 4, WINDING);
		CombineRgn(m_hRgn, m_hRgn, m_hNewRgn, RGN_OR);
		DeleteObject(m_hNewRgn);
	}

	SetWindowRgn(hW, m_hRgn, FALSE);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////////
//Tooltipݒ⏕֐
void CViewPlayer::SetTooltipRect(void){
	PTDIGI_SKIN_BUTTON btnInfo;
	TOOLINFO tli;
	int i;
	int nBtnX;

	if(m_pToolTip != NULL){
		ZeroMemory(&tli,sizeof(TOOLINFO));
		tli.cbSize	= sizeof(tli);

		nBtnX = Calculate_DrawX(&m_DrawRect);
		
		for(i=0;i<m_nBtnSpriteNum;++i){
			if(m_cSkin.GetBtnInfo(i,&btnInfo) == TRUE){

				tli.hwnd	= m_hWnd;
				tli.uId = btnInfo.nFunction;
				
				tli.rect.left   = btnInfo.nX + nBtnX;
				tli.rect.top    = btnInfo.nY + m_DrawRect.top;
				tli.rect.right  = btnInfo.nX + m_pBtnSprite[i].Defautl.GetWidth() + nBtnX;
				tli.rect.bottom = btnInfo.nY + m_pBtnSprite[i].Defautl.GetHeight() + m_DrawRect.top;
				
				m_pToolTip->NewToolRect(&tli);
			}
		}
	}
}

void CViewPlayer::SetToolTipsActivate(BOOL flag){
	if(m_pToolTip != NULL){
		m_flagToolTipActivate = flag;
		m_pToolTip->Activate(flag);
	}
}

BOOL CViewPlayer::GetToolTipsActivate(void){
	return m_flagToolTipActivate;
}

//////////////////////////////////////////////////////////////////////////////
//{^̃Xe[^XXV
//:Ȃ
//߂l:Ȃ
#ifndef CDS_PLAYER_STATUS_STOP
#define CDS_PLAYER_STATUS_STOP 0
#endif
void CViewPlayer::CheckButtonStat(ST_CV_PLY_FUNC_PARAM *pParam){

	//NeBJZNVŕ`揈ی삷
	//CYAutoLock cObjectLock(&m_CreSec);

	PTDIGI_SKIN_BUTTON btnInfo;
	int i;

	for(i=0;i<m_nBtnSpriteNum;++i){
		//{^̏𓾂
		m_cSkin.GetBtnInfo(i,&btnInfo);

		switch(btnInfo.nFunction){
		case PTDIGI_FUNC_VolumeUP:
		case PTDIGI_FUNC_VolumeDown:
			break;
		case PTDIGI_FUNC_iEPG:
		case PTDIGI_FUNC_Exit:
		default:
			break;
		case PTDIGI_FUNC_STOP:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
			else
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			break;
		case PTDIGI_FUNC_PlayerWindow:
			break;
		case PTDIGI_FUNC_ChannelUP:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
			break;
		case PTDIGI_FUNC_ChannelDown:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
			break;
		case PTDIGI_FUNC_Config:
			break;
		case PTDIGI_FUNC_REC:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
			break;
		case PTDIGI_FUNC_Mute:
			break;
		case PTDIGI_FUNC_MuteOff:
			break;
		case PTDIGI_FUNC_SnapShot:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
			break;
		case PTDIGI_FUNC_Ch01:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else{
				if(m_pcSetting != NULL){
					if(m_pcSetting->get_RemCh(0) != -1)
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
					else
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
				}
			}
			break;
		case PTDIGI_FUNC_Ch02:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else{
				if(m_pcSetting != NULL){
					if(m_pcSetting->get_RemCh(1) != -1)
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
					else
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
				}
			}
			break;
		case PTDIGI_FUNC_Ch03:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else{
				if(m_pcSetting != NULL){
					if(m_pcSetting->get_RemCh(2) != -1)
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
					else
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
				}
			}
			break;
		case PTDIGI_FUNC_Ch04:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else{
				if(m_pcSetting != NULL){
					if(m_pcSetting->get_RemCh(3) != -1)
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
					else
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
				}
			}
			break;
		case PTDIGI_FUNC_Ch05:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else{
				if(m_pcSetting != NULL){
					if(m_pcSetting->get_RemCh(4) != -1)
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
					else
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
				}
			}
			break;
		case PTDIGI_FUNC_Ch06:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else{
				if(m_pcSetting != NULL){
					if(m_pcSetting->get_RemCh(5) != -1)
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
					else
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
				}
			}
			break;
		case PTDIGI_FUNC_Ch07:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else{
				if(m_pcSetting != NULL){
					if(m_pcSetting->get_RemCh(6) != -1)
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
					else
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
				}
			}
			break;
		case PTDIGI_FUNC_Ch08:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else{
				if(m_pcSetting != NULL){
					if(m_pcSetting->get_RemCh(7) != -1)
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
					else
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
				}
			}
			break;
		case PTDIGI_FUNC_Ch09:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else{
				if(m_pcSetting != NULL){
					if(m_pcSetting->get_RemCh(8) != -1)
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
					else
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
				}
			}
			break;
		case PTDIGI_FUNC_Ch10:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else{
				if(m_pcSetting != NULL){
					if(m_pcSetting->get_RemCh(9) != -1)
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
					else
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
				}
			}
			break;
		case PTDIGI_FUNC_Ch11:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else{
				if(m_pcSetting != NULL){
					if(m_pcSetting->get_RemCh(10) != -1)
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
					else
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
				}
			}
			break;
		case PTDIGI_FUNC_Ch12:
			if(pParam->nAppStat == VIEW_STATUS_TV_RECORD)
				m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
			else{
				if(m_pcSetting != NULL){
					if(m_pcSetting->get_RemCh(11) != -1)
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DEFAULT;
					else
						m_pBtnSprite[i].nCurrentStyle = PT_BTN_STYLE_DISABLE;
				}
			}
			break;
		}
	}//for(i=0;i<m_nBtnSpriteNum;++i){
}

//c[`bv̕
void CViewPlayer::InitToolTip(void){
	//c[`bvݒ肷
	//c[`bvEChE쐬
	TOOLINFO tli;
	
	if(m_pToolTip == NULL){
		m_pToolTip = new CToolTip;
	}
	
	if(m_pToolTip != NULL){
		m_pToolTip->Create(0,  //gEBhEX^C
							TTS_ALWAYSTIP, // EBhEX^C
							CW_USEDEFAULT, // wW
							CW_USEDEFAULT, // xW
							CW_USEDEFAULT, // 
							CW_USEDEFAULT, // 
							m_hWnd, // eEBhẼnh
							NULL, // j[nh
							m_hInst,
							0);

		ZeroMemory(&tli,sizeof(TOOLINFO));
		tli.cbSize	= sizeof(tli);
		tli.uFlags	= TTF_SUBCLASS;
		tli.hwnd	= m_hWnd;

		tli.hwnd	= m_hWnd;
		tli.lpszText = (LPSTR)IDS_STR_TIP_STOP;
		tli.uId = PTDIGI_FUNC_STOP;
		m_pToolTip->AddTool(&tli);

		tli.hwnd	= m_hWnd;
		tli.lpszText = (LPSTR)IDS_STR_TIP_REC;
		tli.uId = PTDIGI_FUNC_REC;
		m_pToolTip->AddTool(&tli);

		tli.hwnd	= m_hWnd;
		tli.lpszText = (LPSTR)IDS_STR_TIP_VOL_UP;
		tli.uId = PTDIGI_FUNC_VolumeUP;
		m_pToolTip->AddTool(&tli);

		tli.hwnd	= m_hWnd;
		tli.lpszText = (LPSTR)IDS_STR_TIP_VOL_DOWN;
		tli.uId = PTDIGI_FUNC_VolumeDown;
		m_pToolTip->AddTool(&tli);

		tli.hwnd	= m_hWnd;
		tli.lpszText = (LPSTR)IDS_STR_TIP_MUTE;
		tli.uId = PTDIGI_FUNC_Mute;
		m_pToolTip->AddTool(&tli);

		tli.hwnd	= m_hWnd;
		tli.lpszText = (LPSTR)IDS_STR_TIP_CH_DOWN;
		tli.uId = PTDIGI_FUNC_ChannelUP;
		m_pToolTip->AddTool(&tli);

		tli.hwnd	= m_hWnd;
		tli.lpszText = (LPSTR)IDS_STR_TIP_CH_UP;
		tli.uId = PTDIGI_FUNC_ChannelDown;
		m_pToolTip->AddTool(&tli);

		tli.hwnd	= m_hWnd;
		tli.lpszText = (LPSTR)IDS_STR_TIP_SNAPSHOT;
		tli.uId = PTDIGI_FUNC_SnapShot;
		m_pToolTip->AddTool(&tli);

		tli.hwnd	= m_hWnd;
		tli.lpszText = (LPSTR)IDS_STR_TIP_CLOSE;
		tli.uId = PTDIGI_FUNC_Close;
		m_pToolTip->AddTool(&tli);
		
		tli.hwnd	= m_hWnd;
		tli.lpszText = (LPSTR)IDS_STR_TIP_CONFIG;
		tli.uId = PTDIGI_FUNC_Config;
		m_pToolTip->AddTool(&tli);
	
	}
}

//////////////////////////////////////////////////////////////////////////
//obNobt@쐬
//:Ȃ
//߂l:TRUE -> AFALSE -> s
BOOL CViewPlayer::CreateBackBuffer(void){
	HDC hdc;

	//if(m_hWnd == NULL)return FALSE;
	
	hdc = GetDC(NULL);
	if(hdc == NULL)return FALSE;

	//foCXReLXg쐬
	if(m_hDCBackBuf == NULL){
		m_hDCBackBuf = CreateCompatibleDC(hdc);
	}
	
	//foCXReLXg쐬
	if(m_hDCInfoBuf == NULL){
		m_hDCInfoBuf = CreateCompatibleDC(hdc);
	}
	
	//svȃrbg}bv폜
	if(m_hBmpBackBuf != NULL){
		DeleteObject(m_hBmpBackBuf);
		m_hBmpBackBuf = NULL;
	}

	//svȃrbg}bv폜
	if(m_hBmpInfoBuf != NULL){
		DeleteObject(m_hBmpInfoBuf);
		m_hBmpInfoBuf = NULL;
	}

	//rbg}bv쐬
	m_hBmpBackBuf = CreateCompatibleBitmap(hdc,GetSkinWidth(),GetSkinHeight());

	m_hBmpInfoBuf = CreateCompatibleBitmap(hdc,320,64);

	//foCXReLXg
	ReleaseDC(NULL,hdc);

	if(m_hBmpBackBuf == NULL)return FALSE;

	if(m_hOldBackObj != NULL){
		//foCXReLXg̑ĨIuWFNgɖ߂
		SelectObject(m_hDCBackBuf,m_hOldBackObj);
		m_hOldBackObj = NULL;
	}

	//쐬rbg}bvI
	m_hOldBackObj = SelectObject(m_hDCBackBuf,m_hBmpBackBuf);


	if(m_hOldInfoObj != NULL){
		//foCXReLXg̑ĨIuWFNgɖ߂
		SelectObject(m_hDCInfoBuf,m_hOldInfoObj);
		m_hOldInfoObj = NULL;
	}

	//쐬rbg}bvI
	m_hOldInfoObj = SelectObject(m_hDCInfoBuf,m_hBmpInfoBuf);

	return TRUE;
}

void CViewPlayer::OnWmMouseMove(HDC hdc, int xPos,int yPos, long *plVol){


	int i;
	PTDIGI_SKIN_BUTTON btnInfo;		//{^i[p
	int iX,iY;						//{^̍W
	RECT rc;

	//V[No[p
	POINT point;
	long lVol;

	int nBtnX = Calculate_DrawX(&m_DrawRect);

	xPos -= m_DrawRect.left;
	yPos -= m_DrawRect.top;

	//////////////////////////////////////////////////////////////////////////
	//{[ݒ肷
	if(flagVolumeMove == TRUE){

		//ݒ肳ꂽʂ擾
		point.x = xPos - nBtnX;
		point.y = yPos;

		//{[𓾂
		lVol = GetVolumePosFromeVolumeBar(point);
		if(plVol != NULL)*plVol = lVol;

		//R[obN֐Ă
		if(m_pProcVolume != NULL){
			m_pProcVolume(m_pAudioProcParam,lVol);
		}

		//`悷
		DrawVolume(hdc,nBtnX,m_DrawRect.top,lVol);
	}
	
	GetVolumeRect(&rc);
	//ErrMsg("[inf]OnWmMouseMove [volume](%d,%d)-(%d,%d)",rc.left,rc.top,rc.right,rc.bottom);
	if(xPos >= rc.left + nBtnX && xPos <= rc.right + nBtnX &&
		yPos >= rc.top && yPos <= rc.bottom){
		//J[\ݒ肷
		SetCursor(LoadCursor(NULL,IDC_HAND));
	}

	//////////////////////////////////////////////////////////////////////////
	//J[\Ƀ{^邩mF
	for(i=0;i<m_nBtnSpriteNum;++i){
		m_cSkin.GetBtnInfo(i,&btnInfo);

		iX = xPos - btnInfo.nX - nBtnX;
		iY = yPos - btnInfo.nY;

		if((m_pBtnSprite[i].nCurrentStyle != PT_BTN_STYLE_DISABLE)			// gp֎~
		 && (m_pBtnSprite[i].nCurrentStyle != PT_BTN_STYLE_NO_VISIBLE)){	// \
			
			if(m_pBtnSprite[i].Defautl.IsExist(iX,iY) == TRUE){
				//J[\ݒ肷
				SetCursor(LoadCursor(NULL,IDC_HAND));

				if(m_pBtnSprite[i].nCurrentStyle != PT_BTN_STYLE_PUSH){
					//IԂ`悷
					DrawButton(hdc,nBtnX,m_DrawRect.top,i,PT_BTN_STYLE_SELECT,FALSE);
				}
				else{
					//ꂽԂ`悷
					DrawButton(hdc,nBtnX,m_DrawRect.top,i,PT_BTN_STYLE_PUSH,FALSE);
				}
			}
			else{
				//WԂ`悷
				DrawButton(hdc,nBtnX,m_DrawRect.top,i,PT_BTN_STYLE_DEFAULT,FALSE);
			}
		}
		else{
			//ԂłΖԂ`悷
			DrawButton(hdc,nBtnX,m_DrawRect.top,i,PT_BTN_STYLE_DISABLE,FALSE);
		}
	}
}

void CViewPlayer::OnWMLButtonDown(HDC hdc, int xPos,int yPos){

	//ꂽʒũ{^̏ԂύX
	int i;
	PTDIGI_SKIN_BUTTON btnInfo;		//{^i[p
	int iX,iY;						//{^̍W
	RECT rc;

	int nBtnX = Calculate_DrawX(&m_DrawRect);

	xPos -= m_DrawRect.left;
	yPos -= m_DrawRect.top;

	//J[\̉Ƀ{[邩mF
	GetVolumeRect(&rc);
	if(xPos >= rc.left + nBtnX && xPos <= rc.right + nBtnX && 
		yPos >= rc.top && yPos <= rc.bottom ){


		//}EXLv`[ݒ肷
		flagVolumeMove = TRUE;
		SetCapture(m_hWnd);

		//J[\ݒ肷
		SetCursor(LoadCursor(NULL,IDC_HAND));
	}

	//J[\Ƀ{^邩mF
	for(i=0;i<m_nBtnSpriteNum;++i){
		m_cSkin.GetBtnInfo(i,&btnInfo);

		iX = xPos - btnInfo.nX - nBtnX;
		iY = yPos - btnInfo.nY;
		if(m_pBtnSprite[i].Defautl.IsExist(iX,iY) == TRUE ){
			//J[\ݒ肷
			if(m_pBtnSprite[i].nCurrentStyle == PT_BTN_STYLE_DEFAULT ||
				m_pBtnSprite[i].nCurrentStyle == PT_BTN_STYLE_SELECT ||
				m_pBtnSprite[i].nCurrentStyle == PT_BTN_STYLE_PUSH)
			{
					SetCursor(LoadCursor(NULL,IDC_HAND));
					DrawButton(hdc,nBtnX,m_DrawRect.top,i,PT_BTN_STYLE_PUSH,FALSE);
			}
			
			//{^L
			//IsNoBtn = FALSE;
		}
	}
}

//////////////////////////////////////////////////////////////////////////////
//NbN(UP)̏
//:hdc -> `HDC
//     xPos -> J[\XW
//     yPos -> J[\YW
//     DWORD *pdwBtnID -> NbNꂽ{^ID󂯎obt@
//     long *plVol -> {[ύX̎󂯎obt@(0`100)
//߂l:sꂽRg[ID(VP_CTRL_XXXŒ`)      
DWORD CViewPlayer::OnWMLButtonUp(HDC hdc, int xPos,int yPos,int *pnBtnID, long *plVol){

	//PUSHԂŊNbNオꍇ̓R}h𔭍s
	//{^グꂽʒũ{^̏ԂmF
	int i;
	PTDIGI_SKIN_BUTTON btnInfo;		//{^i[p
	int iX,iY;						//{^̍W

	int nBtnX = Calculate_DrawX(&m_DrawRect);

	xPos -= m_DrawRect.left;
	yPos -= m_DrawRect.top;

	//V[No[p
	POINT point;
	long lVol;

	//{[ݒ肷
	if(flagVolumeMove == TRUE){
		//ݒ肳ꂽʂ擾
		point.x = xPos - nBtnX;
		point.y = yPos;

		lVol = GetVolumePosFromeVolumeBar(point);
		if(plVol != NULL)*plVol = lVol;
		
		//`sȂ
		DrawVolume(hdc,nBtnX,m_DrawRect.top,lVol);
		
		//}EXLv`[
		ReleaseCapture();
		flagVolumeMove = FALSE;

		//J[\ݒ肷
		SetCursor(LoadCursor(NULL,IDC_HAND));
		
		return VP_CTRL_VOLUME;
	}

	//J[\Ƀ{^邩mF
	for(i=0;i<m_nBtnSpriteNum;++i){
		m_cSkin.GetBtnInfo(i,&btnInfo);


		iX = xPos - btnInfo.nX - nBtnX;
		iY = yPos - btnInfo.nY;
		
		if(m_pBtnSprite[i].Defautl.IsExist(iX,iY) == TRUE){
			if(m_pBtnSprite[i].nCurrentStyle == PT_BTN_STYLE_PUSH){

				DrawButton(hdc,nBtnX,m_DrawRect.top,i,PT_BTN_STYLE_SELECT,FALSE);

				//J[\ݒ肷
				SetCursor(LoadCursor(NULL,IDC_HAND));
				if(pnBtnID != NULL)*pnBtnID = btnInfo.nFunction;
				
				return VP_CTRL_BUTTON;
			}
		}
	}

	return VP_CTRL_NONE;
}


void CViewPlayer::OnWmTimer_InfoScroll(void){
	
	if(m_nDrawPos + m_nDrawInfoWidth > m_nDrawMaxWidth){
		//Ō܂ł[邵̏
		if(m_nDrawPosWait < PLAYER_INFO_SCROLL_WAIT){
			++m_nDrawPosWait;
		}
		else{
			m_nDrawPos = 0;
		}
	}
	else{
		//XN[̏
		if(m_nDrawPosWait <= 0)
			m_nDrawPos += 2;
		else 
			m_nDrawPosWait -= 1;

	}
}

